
import std.c.stdio;

import std.asserterror;

import win32.api;
import dfc.core;
import dfc.button;
import dfc.tree;
import dfc.edit;
import dfc.dstatic;

class MyApp : DApp {
	this() {
		super();
		create(	WS_DLGFRAME | WS_MAXIMIZEBOX | WS_MINIMIZEBOX | WS_SYSMENU|WS_CLIPCHILDREN,
					0,
					"DFC test",
					400, 200 );
		addPaintHandler( WM_PAINT, &onPaint );
	}
		LRESULT onPaint( HDC dc ) {
			RECT rect;
			getClientRect( rect );
			HBRUSH fill = CreateSolidBrush( 0xCCCCCC );
			FillRect( dc, &rect, fill );
			DeleteObject( fill );
			return cast(LRESULT)0;
		}
}

class MyButton : DButton {
	this( char[] title, int x, int y, int w, int h, DWnd parent ) {
		create(
				WS_CHILD|BS_VCENTER | BS_PUSHBUTTON | BS_CENTER |WS_VISIBLE,
				WS_EX_STATICEDGE,
				title,
				x, y, w, h,
				parent, null );
	}
}

class MyGroup : DButton {
	this( char[] title, int x, int y, int w, int h, DWnd parent ) {
		create(
				WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
				WS_EX_TRANSPARENT,
				title,
				x, y, w, h,
				parent, null );
	}
}

class MyLabel : DStatic {
	this( char[] title, int x, int y, int w, int h, DWnd parent ) {
		create(
				WS_CHILD|WS_VISIBLE|SS_CENTER,
				0,
				title,
				x, y, w, h,
				parent, null );
	}
}
class MyFrame : DStatic {
	this( char[] title, DWnd parent ) {
		RECT r;
		parent.getClientRect( r );
		create(
				WS_CHILD|WS_VISIBLE|SS_ETCHEDFRAME,
				WS_EX_TRANSPARENT,
				title,
				2, 2, (r.right-r.left)-4, (r.bottom-r.top)-4,
				parent, null );
	}
}

int main( char[][] args )
{
	try {
		printf( "<starting>\n" );
		DApp app;
		DButton button;
		DButton group;
		DStatic frame;
		DStatic info;

		DFC.beginApplication( true );

		app = new MyApp();
		frame = new MyFrame( "Frame", app );
		group = new MyGroup( "Stuff in a group", 10, 12, 110, 30, app);
		button = new MyButton("Hello World", 5, 132, 110, 30, app);
		info = new MyLabel( "Tell me more", 150, 100, 110, 70, app);

		printf( "<ready>\n" );

		app.showWindow( true );
		InvalidateRect( app.getHwnd(), null, true );
		DFC.msgLoop();

	} catch ( Exception e ) {
		printf( "Caught : %.*s\n", e.toString() );
		return 0;
	} catch ( Object o ) {
		printf( "Caught : %.*s\n", o.toString() );
		return 0;
	}
	printf( "<done>\n" );
	return 0;
}
